#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <vector>
#include <valarray>
#include <stack>
#define MAX 210000
#define LIMIT 1000000000

using namespace std;
typedef valarray<long long> VI;
typedef stack<VI> SVI;
typedef vector<bool> VB;

inline bool wykonaj(SVI& Stos, VB& E, const char* polec, int x)
{
    int n=(int)E.size();
    if (!strcmp(polec,"NUM")) Stos.push(VI(x,n));
    else if (!strcmp(polec,"POP"))
    {
        if (Stos.size()<1) return true; //Error
        Stos.pop();
    }
    else if (!strcmp(polec,"INV"))
    {
        if (Stos.size()<1) return true; //Error
        VI Z=Stos.top(); Stos.pop();
        Stos.push(-Z);
    }
    else if (!strcmp(polec,"DUP"))
    {
        if (Stos.size()<1) return true; //Error
        Stos.push(Stos.top());
    }
    else if (!strcmp(polec,"SWP"))
    {
        if (Stos.size()<2) return true; //Error
        VI A=Stos.top(); Stos.pop();
        VI B=Stos.top(); Stos.pop();
        Stos.push(A); Stos.push(B);
    }
    else if (!strcmp(polec,"ADD"))
    {
        if (Stos.size()<2) return true; //Error
        VI A=Stos.top(); Stos.pop();
        VI B=Stos.top(); Stos.pop();
        
        VI Wyn=B+A;
        for (int i=0; i<n; ++i)
        {
            if (Wyn[i]>LIMIT || Wyn[i]<-LIMIT) E[i]=true;
        }
        
        Stos.push(Wyn);
    }
    else if (!strcmp(polec,"SUB"))
    {
        if (Stos.size()<2) return true; //Error
        VI A=Stos.top(); Stos.pop();
        VI B=Stos.top(); Stos.pop();
        
        VI Wyn=B-A;
        for (int i=0; i<n; ++i)
        {
            if (Wyn[i]>LIMIT || Wyn[i]<-LIMIT) E[i]=true;
        }
        
        Stos.push(Wyn);
    }
    else if (!strcmp(polec,"MUL"))
    {
        if (Stos.size()<2) return true; //Error
        VI A=Stos.top(); Stos.pop();
        VI B=Stos.top(); Stos.pop();
        
        VI Wyn=B*A;
        for (int i=0; i<n; ++i)
        {
            if (Wyn[i]>LIMIT || Wyn[i]<-LIMIT) E[i]=true;
        }
        
        Stos.push(Wyn);
    }
    else if (!strcmp(polec,"DIV"))
    {
        if (Stos.size()<2) return true; //Error
        VI A=Stos.top(); Stos.pop();
        VI B=Stos.top(); Stos.pop();
        
        for (int i=0; i<n; ++i)
        {
            if (A[i]==0LL)
            {
                E[i]=true;
                A[i]=1LL;
            }
        }
        
        VI Wyn(n);
        for (int i=0; i<n; ++i)
        {
            Wyn[i]=abs(B[i])/abs(A[i]);
            if (A[i]*B[i]<0) Wyn[i]=-Wyn[i];
        }
        
        Stos.push(Wyn);
    }
    else if (!strcmp(polec,"MOD"))
    {
        if (Stos.size()<2) return true; //Error
        VI A=Stos.top(); Stos.pop();
        VI B=Stos.top(); Stos.pop();
        
        for (int i=0; i<n; ++i)
        {
            if (A[i]==0LL)
            {
                E[i]=true;
                A[i]=1LL;
            }
        }
        
        VI Wyn(n);
        for (int i=0; i<n; ++i)
        {
            Wyn[i]=abs(B[i])%abs(A[i]);
            if (B[i]<0) Wyn[i]=-Wyn[i];
        }
        Stos.push(Wyn);
    }
    
    return false;
}

int main()
{
    //printf("13/(-4)=%d; (-13)/4=%d; (-13)/(-4)=%d; 13%(-4)=%d; (-13)%4=%d; (-13)%(-4)=%d", 13/(-4),(-13)/4,(-13)/(-4),13%(-4),(-13)%4,(-13)%(-4));
    
    //return 0;
    
    while (true)
    {
        char buf[10]={};
        scanf("%s",buf);
        if (!strcmp(buf,"QUIT")) break;
        
        char cmd[MAX][12]={};
        int licz=0;
        strcpy(cmd[licz++],buf);
         
        while (true)
        {
            scanf("%s",cmd[licz++]);
            if (!strcmp(cmd[licz-1],"END")) break;
        }
        
        int n; scanf("%d",&n);
        SVI V; VB E(n,false); VI Z(n);
        for (int i=0; i<n; ++i) scanf("%d",&Z[i]);
        V.push(Z);
        
        for (int pol=0; pol<licz-1; ++pol)
        {
            int x=-1;
            const char* polec=cmd[pol];
            if (!strcmp(polec,"NUM"))
            {
                const char* liczba=cmd[pol+1];
                x=atoi(liczba);
            }
            if (wykonaj(V,E,cmd[pol],x)) break;
        }
        if (V.size()!=1)
        {
            for (int i=0; i<n; ++i) printf("ERROR\n");
        }
        else
        {
            VI Z=V.top();
        
            for (int i=0; i<n; ++i)
            {
                if (E[i]) printf("ERROR\n");
                else printf("%lld\n",Z[i]);
            }
        }
        printf("\n");
    }
    
    return 0;
}
